function get_browser_info(){
    console.log("getting browser verison");
	var ua=navigator.userAgent,tem,M=ua.match(/(opera|chrome|safari|firefox|msie|trident(?=\/))\/?\s*(\d+)/i) || []; 
    if(/trident/i.test(M[1])){
        tem=/\brv[ :]+(\d+)/g.exec(ua) || []; 
        return {name:'IE ',version:(tem[1]||'')};
        }   
    if(M[1]==='Chrome'){
        tem=ua.match(/\bOPR\/(\d+)/)
        if(tem!=null)   {return {name:'Opera', version:tem[1]};}
        }   
    M=M[2]? [M[1], M[2]]: [navigator.appName, navigator.appVersion, '-?'];
    if((tem=ua.match(/version\/(\d+)/i))!=null) {M.splice(1,1,tem[1]);}
    return {
      name: M[0],
      version: M[1]
    };
}
 
/* THIS FUNCTION WILL BE USED INSTEAD OF CONSOLE.LOG - THIS WILL ENABLE US TO SHOW SPECIFIC MESSAGES: */
var message_indent = 0;
function courseMessage(Output, type, indent) {
	if(arguments.length === 1) {
		type=0;
		indent=undefined;
	}
	if(arguments.length === 2) {		
		indent=undefined;
	}
	/* GET THE DISPLAY TYPE - IF NULL ONLY SHOW 'ERROR/IMPORTANT MESSAGES' */
	var display_type = getQueryVariable("message");
	/* CHECK SCORM DEBUG VALUE ON THE COURSE OBJECT IF AVAILABLE: */
	
	if(display_type==undefined || display_type==""){
		
		if(course.scorm_debug!=undefined && course.scorm_debug!="") {
			
			try {
				display_type = parseInt(course.scorm_debug);
			} catch(e) {}
		} else {
			
			display_type = 2;			
		}		 
	}
	if(display_type=="all" || display_type=="test"){
		display_type = 5;
	}
	
	/*THROW AN ERROR TO GET THE CALLING FUNCTION NAME/LINE, ETC:*/	
	var e = new Error();
	if (!e.stack) try {
    // IE requires the Error to actually be throw or else the Error's 'stack'
    // property is undefined.
    throw e;
	} catch (e) {
		if (!e.stack) {
			return 0; // IE < 10, likely
		}
	}
	var stack = e.stack.toString().split(/\r\n|\n/);
	//console.log("Stack: "+stack);
	// We want our caller's frame. It's index into |stack| depends on the
	// browser and browser version, so we need to search for the second frame:
	var frameRE = /:(\d+):(?:\d+)[^\d]*$/;
	/*NO IDEA HOW THIS WORKS, BUT IT SHIFTS THE STACK UNTIL YOU ARE AT THE CALLING FUNCTION:*/
	do {
		var frame = stack.shift();		
	} while (!frameRE.exec(frame) && stack.length);
	
	//console.log("Testing message with call info...", '          [' +stack[0] + ']');   
	 
	
	/* 
		TYPES OF MESSAGES: 
		1=Error/Warning/Reminders
		2=Important/Structure/Flow
		3=Information/Comments
		4=Debug/Detailed
		5=Testing/Temp
		
		Types of display types - in queryString messages=x
		null=Error/Important Only.
		1-5= the level set+any higher level message
		all=display all messages
		
		Identifier: should list the function Name, section that the message is coming from
	*/
	var typeArray = ["Err", "Imp", "Cmt", "Dbg", "Tst"];
	
	/* 
	OUTPUT FORMAT:
		[**Type**]: Output [calling_info]
	*/
	
	/* IF THE MESSAGE TYPE ISNT SET DEFAULT: */
	if(type==0) {
		type=5;
	}
	
	/* CREATE THE MESSAGE STRING: */
	
	/* GET THE OUTPUT TYPE? WRITE TO CONSOLE OR OTHER OUTPUT STREAMS? */
	
	/* SET COLOR */
	if (type==1){
		message_color = "red"
	}
	else if (type==2){
		message_color = "blue"
	}
	else if (type==3){
		message_color = "green"
	}
	else if (type==4){
		message_color = "brown"
	} else {		
		message_color = "gray"
	}
	
	if(indent==0) {
		message_indent--;
	}
	/*CHECK TO SEE IF THE MESSAGE SHOULD BE WRITTEN OR NOT: */
	if(display_type=="all" || display_type >= type){
		try{
			indent_string = "..".repeat(message_indent);
		} catch (e) {
			indent_string = "[IE-INDENT]";
		}
	 console.log("%c"+indent_string+"[**"+typeArray[type-1]+"**]: "+Output+"\n        [" +stack[0] + "]","color: "+message_color+";");
	}
	if(indent==1) {
		message_indent++;
	}
 }